//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.form;

//===========================================================================
// import
//===========================================================================
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

import java.io.UnsupportedEncodingException;

import jp.gr.java_conf.bugslife.util.*;
/**
 *<PRE>
 * UserEditFormクラス
 *
 *</PRE>
 * @author 鰐川　正寛
 * @version 1.0.0
 */
public class UserEditForm1 extends ValidatorForm {
//===========================================================================
// attributes
//===========================================================================
	/**
	 * uno
	 */
	private int m_uno;
	/**
	 * uid
	 */
	private String m_uid;
	/**
	 * 旧パスワード
	 */
	private String m_oldPassword;
	/**
	 * 新パスワード
	 */
	private String m_newPassword;
	/**
	 * 新パスワード２
	 */
	private String m_newPassword2;
	/**
	 * 氏名
	 */
	private String m_name;
	/**
	 * 略称
	 */
	private String m_nickname;
	/**
	 * メールアドレス
	 */
	private String m_email;
	/**
	 * 会社名
	 */
	private String m_company;
	/**
	 * 部署
	 */
	private String m_section;
	/**
	 * 電話番号
	 */
	private String m_tel;
	/**
	 * メモ
	 */
	private String m_memo;
	/**
	 * 使用言語
	 */
	private int m_language;
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 * unoのセット
	 * 
	 * @param uno uno
	 */
	public void setUno(int uno) {
		m_uno = uno;
	}
	/**
	 * unoの取得
	 * 
	 * @return uno
	 */
	public int getUno() {
		return m_uno;
	}
	/**
	 * ユーザIDの取得
	 * 
	 * @return ユーザID
	 */
	public String getUid()
	{
		return m_uid;
	}
	/**
	 * ユーザIDのセット
	 * 
	 * @param uid ユーザID
	 */
	public void setUid(String uid)
	{
		m_uid = uid;
	}
	/**
	 * 旧パスワードのセット
	 * 
	 * @param oldPassword 旧パスワード
	 */
	public void setOldPassword(String oldPassword) {
		m_oldPassword = oldPassword;
	}
	/**
	 * 旧パスワードの取得
	 * 
	 * @return 旧パスワード
	 */
	public String getOldPassword() {
		return m_oldPassword;
	}
	/**
	 * 新パスワードのセット
	 * 
	 * @param newPassword 新パスワード
	 */
	public void setNewPassword(String newPassword) {
		m_newPassword = newPassword;
	}
	/**
	 * 新パスワードの取得
	 * 
	 * @return 新パスワード
	 */
	public String getNewPassword() {
		return m_newPassword;
	}
	/**
	 * 新パスワード２のセット
	 * 
	 * @param password2 新パスワード２
	 */
	public void setNewPassword2(String newPassword2) {
		m_newPassword2 = newPassword2;
	}
	/**
	 * 新パスワード２の取得
	 * 
	 * @return 新パスワード２
	 */
	public String getNewPassword2() {
		return m_newPassword2;
	}
	/**
	 * 氏名のセット
	 * 
	 * @param name 氏名
	 */
	public void setName(String name) {
		m_name = name;
	}
	/**
	 * 氏名の取得
	 * 
	 * @return 氏名
	 */
	public String getName() {
		return m_name;
	}
	/**
	 * 略称のセット
	 * 
	 * @param nickname 略称
	 */
	public void setNickname(String nickname) {
		m_nickname = nickname;
	}
	/**
	 * 略称の取得
	 * 
	 * @return 略称
	 */
	public String getNickname() {
		return m_nickname;
	}
	/**
	 * メールアドレスのセット
	 * 
	 * @param email メールアドレス
	 */
	public void setEmail(String email) {
		m_email = email;
	}
	/**
	 * メールアドレスの取得
	 * 
	 * @return メールアドレス
	 */
	public String getEmail() {
		return m_email;
	}
	/**
	 * 会社名のセット
	 * 
	 * @param company 会社名
	 */
	public void setCompany(String company) {
		m_company = company;
	}
	/**
	 * 会社名の取得
	 * 
	 * @return 会社名
	 */
	public String getCompany() {
		return m_company;
	}
	/**
	 * 部署のセット
	 * 
	 * @param section 部署
	 */
	public void setSection(String section) {
		m_section = section;
	}
	/**
	 * 部署の取得
	 * 
	 * @return 部署
	 */
	public String getSection() {
		return m_section;
	}
	/**
	 * 電話番号のセット
	 * 
	 * @param tel 電話番号
	 */
	public void setTel(String tel) {
		m_tel = tel;
	}
	/**
	 * 電話番号の取得
	 * 
	 * @return 電話番号
	 */
	public String getTel() {
		return m_tel;
	}
	/**
	 * メモのセット
	 * 
	 * @param memo メモ
	 */
	public void setMemo(String memo) {
		m_memo = memo;
	}
	/**
	 * メモの取得
	 * 
	 * @return メモ
	 */
	public String getMemo() {
		return m_memo;
	}
	/**
	 * 言語のセット
	 * 
	 * @param memo 言語
	 */
	public void setLanguage(int language) {
		m_language = language;
	}
	/**
	 * 言語の取得
	 * 
	 * @return 言語
	 */
	public int getLanguage() {
		return m_language;
	}
	public String toString() {
		
		StringBuffer sb = new StringBuffer();
		sb.append("oldPassword :"  + m_oldPassword + "\n");
		sb.append("newPassword :"  + m_newPassword + "\n");
		sb.append("newPassword2:"  + m_newPassword2 + "\n");
		sb.append("name        :"  + m_name + "\n");
		sb.append("nickname    :"  + m_nickname + "\n");
		sb.append("email       :"  + m_email + "\n");
		sb.append("company     :"  + m_company + "\n");
		sb.append("section     :"  + m_section + "\n");
		sb.append("tel         :"  + m_tel + "\n");
		sb.append("memo        :"  + m_memo + "\n");
		sb.append("language    :"  + m_language + "\n");
		
		return new String(sb);
	}
//===========================================================================
// Public Methods
//===========================================================================
	/**
	* リセット
	*
	* @param mapping The mapping used to select this instance
	* @param request The servlet request we are processing
	*/
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		//debug
		log.debug("reset");
		//encodeing セット
		try {
			request.setCharacterEncoding("SJIS");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
		m_uid = null;
		m_oldPassword = null;
		m_newPassword = null;
		m_newPassword2 = null;
		m_name = null;
		m_nickname = null;
		m_email = null;
		m_company = null;
		m_section = null;
		m_tel = null;
		m_memo = null;
//		m_language = 0;
	}
	/**
	* 値の検証(Validate) 
	*
	* @param mapping The mapping used to select this instance
	* @param request The servlet request we are processing
	*/
	public ActionErrors validate(ActionMapping mapping,
								 HttpServletRequest request) {
		ActionErrors errors = new ActionErrors();
	
		log.debug("validate");
		log.debug(toString());
		
		//新規の場合
		if (m_uno == 0) {
			//uid
			Varidater.checkRequired(m_uid, "uid", errors);
		}
		
		
		//パスワードチェック
		boolean oldP = Varidater.isInput(m_oldPassword);
		boolean newP = Varidater.isInput(m_newPassword);
		boolean newP2 = Varidater.isInput(m_newPassword2);
		
		//新規の場合
		if (m_uno == 0) {
			//新パスワード、新パスワード２は必須
			Varidater.checkRequired(m_newPassword, "password", errors);
			Varidater.checkRequired(m_newPassword2, "password2", errors);
			//両方とも指定されていれば
			if (newP && newP2) {
				//パスワード一致チェック
				Varidater.checkSame(m_newPassword, m_newPassword2, "password", "password2", errors);
			}
		//変更の場合
		} else {
			//どれか１つでも指定されていれば、３つとも必須
			if ((oldP || newP) || newP2) {
				Varidater.checkRequired(m_oldPassword, "oldPassword", errors);
				Varidater.checkRequired(m_newPassword, "newPassword", errors);
				Varidater.checkRequired(m_newPassword2, "newPassword2", errors);
			}
			//３つとも指定されていれば
			if ((newP && newP2) && (oldP)) {
				//パスワード一致チェック
				Varidater.checkSame(m_newPassword, m_newPassword2, "newPassword", "newPassword2", errors);
			}
		}
		//name
		Varidater.checkRequired(m_name, "name", errors);
		//nickname
		Varidater.checkRequired(m_nickname, "nickname", errors);
		//email
		if (Varidater.checkRequired(m_email, "email", errors)) {
/*---------------------------------- エラーになるのでコメントアウト
			//形式チェック
			Varidater.checkEmail(m_email, "email", errors);
-------------------------------------------------------------------*/
		}
		
		return errors;
	}
}